window.common = {
	devicesType : "",
	version:"",
	//根据UA初始化设备类型
	initDeviceInfo:function(){
		//根据UA判断当前的设备类型
		var UA = navigator.userAgent.toUpperCase();

		if(UA.indexOf("IPHONE") > -1 || UA.indexOf("IPOD") > -1 || UA.indexOf("IPAD") > -1){
			this.devicesType = "IOS";
		}

		if(UA.indexOf("ANDROID") > -1){
			this.devicesType = "ANDROID";
		}
	},
	// 扩展对象  把source的属性复制到target中
	extend:function(target,source){
		for (var p in source) {
			target[p] = source[p];
		}
	},
	/**
	 * 获取URL中的search字符串的值
	 * @param  {String} key [获取的值的key]
	 * @return {String}     [获取值的value]
	 */
	getSearchValue:function(key){
		var searchStr = location.search.replace(/^\?/,"").replace(/#,*$/,""),
			searchArray = searchStr.split("&"),
			searchJSON = {};

		for (var i = 0; i < searchArray.length; i++) {
			if(searchArray[i].split("=").length === 2){
				searchJSON[searchArray[i].split("=")[0]] = searchArray[i].split("=")[1];
			}
		}
		return searchJSON[key] || "";
	},
	/**
	 * 埋点的方法
	 * @param  {String} actionId    动作ID
	 * @param  {String} processId   步骤ID
	 * @param  {String} actionInfo  备注
	 */
	buried:function(actionId,processId,actionInfo){
		var data = {
			actionId:actionId,
			processId:processId
		}
		if(actionInfo){data.actionInfo = actionInfo} 
		this.nativeCall("buried","",data)
	},
	/**
	 * 根据手机号码获取运营商类型
	 * @param  {String} mobileNum 手机号码
	 * @return {String}           运营商类型   DX:电信  LT:联通  YD:移动
	 */
	getMobileType:function(mobileNum){
		// 运营商电话号码规则 先判断电信再判断移动  DX LT YD
		var rule = [["133","153","177","180","181","189","1349","1700"],["130","131","132","145","155","156","176","185","186"],["134","135","136","137","138","139","150","151","152","157","158","159","182","183","184","187","178","188","147","1705"]]
		//遍历数组 
		for(var i = 0; i < rule.length; i++){
			for(var j = 0; j < rule[i].length; j++){
				if(mobileNum.indexOf(rule[i][j]) === 0){
					return ["DX","LT","YD"][i];
				}
			}
		}
	},
	//给页面添加webtrends埋点
	addWebtrends:function(data){
		var imgNode = document.createElement("IMG");
		imgNode.src = "http"+(window.location.protocol.indexOf('https:')==0?'s':'')+"://sdc.pingan.com/dcskftxv6akqoaoyyccgcdnxe_1n6k/dcs.gif?dcsdat="+(new Date()).getTime()+"&dcssip="+window.location.hostname+"&dcsuri="+window.location.pathname+"&dcsqry="+window.location.search+"&WT.tz=8&WT.js=Yes&WT.ti=" + data;
		document.body.appendChild(imgNode)
	},
	/**
	 * 调用Native方法
	 * @param  {String}   method   [调用的方案名]
	 * @param  {String}   callback [回调的函数名]
	 * @param  {Object}   param    [参数]
	 */
	nativeCall:function(method,callback,param){
		setTimeout(function(){
			!method && (method = "",console.warn("method参数为必选"));
			typeof param === "string" ? (param = encodeURIComponent(param)) : (param = encodeURIComponent(JSON.stringify(param)));
			var iframe = document.createElement("iframe");
			iframe.src = "pawifi://method=" + method + (callback ? "&callback=" + callback : "") + (param ? "&param=" + param : "");;
			iframe.style.display = "none";
			document.body.appendChild(iframe);
			iframe.parentNode.removeChild(iframe);
			console.log("method:" + method + "; callback:" + callback + "; param:" + param)
		})
	},
	//供Native调用的重新登入方法
	relogin:function(){
		this.nativeCall("showDialog","",{
			"content":"您的手机号在另一台设备登录，如需继续使用平安WiFi，请重新登录。",
			"okName":"重新登录",
			"cancelName":"暂不登录",
			"okCallback":"common.reloginCallback"
		})
	},
	reloginCallback:function(){
        location.href = "login.html";
	},
	init:function(){
		this.initDeviceInfo();
	}
}
common.init();