window.connect = {
	// 当前连接的SSID
	connectSSID:"",
	// 任务ID
	progressCircleID:"",
	progressCircle:function(step,time,connectError){
		//创建canvas节点用来绘制进度圈
		var canvasNode = document.createElement("CANVAS"),
			stepNode = document.querySelector("#step"+step),
			ctx = canvasNode.getContext('2d'),
			speed = Math.PI * 2 / time / 30,
			end = -Math.PI;

		// 清除上次转圈的任务
		clearInterval(this.progressCircleID);

		//标记当前进行的步骤
		this.step = step;

		// 设置canvas节点的高度和宽度 并把节点插入到dom中
		canvasNode.height = stepNode.offsetHeight;
		canvasNode.width = stepNode.offsetWidth;
		stepNode.querySelector("canvas") && (stepNode.removeChild(stepNode.querySelector("canvas")));
		stepNode.appendChild(canvasNode);
		stepNode.classList.add("ing")

		var draw = function(){
			//清除像素
			ctx.clearRect(0,0,60,60);
  			//draw face
  			ctx.beginPath();    		
  			//设置弧线的颜色为白色
    		ctx.strokeStyle = connectError ? "#ed583f" : "rgba(255,255,255,.8)";
    		ctx.lineWidth = 2;
    		ctx.lineCap="round";
  			ctx.arc(30, 30, 29, -Math.PI, end);
  			ctx.stroke();
  			end += speed;
  			if(end > Math.PI * 1.5){
  				clearInterval(this.progressCircleID);
  			}
		}.bind(this)

		//time ===0 的情况 需要圈转满
		if(time === 0){
			stepNode.classList.add(connectError ? "error" : "success");
			end = Math.PI * 1.5;
			draw()
			return;
		}

		this.progressCircleID = setInterval(draw,1000 / 30)
	},
	//删除所有的转圈圈状态
	removeCircle:function(){
		[].slice.call(document.querySelectorAll(".step")).forEach(function(node){
			node.className = "step";
			node.querySelector("canvas") && (node.removeChild(node.querySelector("canvas")));
		});
		document.querySelectorAll(".line img")[0].src="images/connect/connect_nor.png";
		document.querySelectorAll(".line img")[1].src="images/connect/connect_nor.png";
		var despNode = document.querySelectorAll(".desp span");
		despNode[0].innerHTML = "获取账号";
		despNode[1].innerHTML = "分配IP";
		despNode[2].innerHTML = "连接网络";
	},
	/**
	 * 显示成功或失败的界面
	 * @param  {[type]} success 是否为成功的提示  默认不展示
	 */
	showRetry:function(success){
		// 配置每种异常的显示信息和是否显示重试按钮
		var config = {
			"getCardFail_ChangeWiFi":{
				msg:"获取上网凭证失败",
				buttonDisplay:["retry"]
			},
			"getCardFail_OpenMobileData":{
				msg:"获取上网凭证失败，需耗少量数据流量<br>打开2G/3G/4G网络后重试",
				buttonDisplay:["retry"]
			},
			"connectWifiFail_SsidNotExist":{
				msg:"WiFi网络状况不佳或连接人数过多，无法联网",
				buttonDisplay:["retry"]
			},
			"connectWifiFail_SsidQualityBad":{
				msg:"WiFi网络状况不佳或连接人数过多，无法联网",
				buttonDisplay:["retry"]
			},
			"loginApFail_VerifyFail":{
				msg:"抱歉，WiFi不能上网",
				buttonDisplay:["retry"]
			},
			"loginApFail_APDisConnect":{
				msg:"WiFi异常断开，无法联网",
				buttonDisplay:["retry"]
			},
			"WIFI_NO_NET":{
				msg:"抱歉，WiFi不能上网",
				buttonDisplay:["disconnect"]
			},
			"loginApSuccess":{
				msg:"恭喜您已免费上网",
				buttonDisplay:["disconnect"]
			}
		}
		if(success){
			common.nativeCall("setTitle","","连接成功");
		}else{
        	common.nativeCall("setTitle","","连接失败");
        	this.progressCircle(this.step,0,true);
		}
		document.querySelector(".waitconnect").style.display = "none";
		document.querySelector("#retryWrap").style.display = "block";
		document.querySelector(".retryTip").innerHTML = config[this.connectStatus].msg;
		[].slice.call(document.querySelectorAll("#retryWrap .button")).forEach(function(node){
			if(config[this.connectStatus].buttonDisplay.indexOf(node.dataset.action) >-1 ){
				node.style.display = "block";
			}else{
				node.style.display = "none";
			}
		}.bind(this));
	},
	// 当前连接状态
	connectStatus:"",
	// 当前进行到第几步
	step:1,
	// 连接SSID的回调
	connectCallback:function(data){
		data = JSON.parse(data);
		this.connectStatus = data.status;
		var line1 = document.querySelectorAll(".line img")[0],
			line2 = document.querySelectorAll(".line img")[1],
			despNode = document.querySelectorAll(".desp span");
		switch(data.status){
			// 拿卡成功
			case "getCardSuccess":
				this.progressCircle(1,0);
				this.progressCircle(2,35);
				line1.src = "images/connect/connect_ing.png";
				common.buried("20003",2,{SSID:this.connectData.SSID,connectBSSID:this.connectData.BSSID});
				break
			// 连接成功
			case "connectWifiSuccess":
				this.progressCircle(1,0)
				this.progressCircle(2,0)
				this.progressCircle(3,60)
				line1.src = "images/connect/connect_suc.png";
				line2.src = "images/connect/connect_ing.png";
				common.buried("20003",5,{SSID:this.connectData.SSID,connectBSSID:this.connectData.BSSID});
				break
			// 总的成功
			case "loginApSuccess":
				this.progressCircle(1,0)
				this.progressCircle(2,0)
				this.progressCircle(3,0)
				line1.src = line2.src= "images/connect/connect_suc.png";
				this.showRetry(true)
        		common.buried("20003",7,{SSID:this.connectData.SSID,connectBSSID:this.connectData.BSSID});
				break
			// 用户已打开数据网络：提示切换其他免费WiFi
			case "getCardFail_ChangeWiFi":
			// 用户已关闭数据网络：提示打开数据网络
			case "getCardFail_OpenMobileData":
				despNode[0].innerHTML = "获取失败";
        		common.buried("20003",3,{SSID:this.connectData.SSID,connectBSSID:this.connectData.BSSID,error:data.status});
				this.showRetry();
				break
			// WiFi不存在：提示超出范围
			case "connectWifiFail_SsidNotExist":
			// 除WiFi不存在：提示WiFi质量不佳人数过多
			case "connectWifiFail_SsidQualityBad":
				despNode[1].innerHTML = "分配失败";
        		common.buried("20003",4,{SSID:this.connectData.SSID,connectBSSID:this.connectData.BSSID,error:data.status});
				this.showRetry();
				break
			// 网络验证失败，不能上网
			case "loginApFail_VerifyFail":
			// WiFi断开，提示WiFi异常断开，网络验证失败
			case "loginApFail_APDisConnect":
				despNode[2].innerHTML = "连网失败";
        		common.buried("20003",6,{SSID:this.connectData.SSID,connectBSSID:this.connectData.BSSID,error:data.status});
				this.showRetry();
				break
			// 有portal页的WiFi已连接，但不能上网
			case "WIFI_NEED_LOGIN":
				common.nativeCall("showPortal");
				location.href = "list.html";
				break
			// 无portal页的WiFi已连接，但不能上网：
			case "WIFI_NO_NET":
				despNode[2].innerHTML = "连网失败";
				this.showRetry();
				break
		}
	},
	connect:function(){
		//重置连接状态  因需要在返回时根据连接状态显示提示框
		this.connectStatus = "";
        common.nativeCall("setTitle","","正在连接 " + this.connectData.SSID);
        common.nativeCall("updateConnectStatus","connect.connectCallback",this.connectData.SSID);
		common.buried("20003",1,{SSID:this.connectData.SSID,connectBSSID:this.connectData.BSSID});
	},
	moveStatus:false,
	//绑定事件
	bindEvent:function(){
		document.addEventListener("touchmove",function(e){
			this.moveStatus = true;
		}.bind(this));
		document.body.addEventListener("touchend",function(e){
			if(this.moveStatus){this.moveStatus = false;return};

			var action = e.target.dataset.action;
			switch(action){
				case "retry":
					this.connect();
					document.querySelector(".waitconnect").style.display = "block";
					document.querySelector("#retryWrap").style.display = "none";
					this.removeCircle();
					this.progressCircle(1,10);
					break;
				case "disconnect":
					common.nativeCall("disconnectNetwork");
					location.href = "list.html";
					break;
			}
		}.bind(this));
	},
	//放弃连接的回调
	giveUpConnectCallback:function(){
        common.buried("20003",8,{SSID:this.connectData.SSID,connectBSSID:this.connectData.BSSID});
		common.nativeCall("cancleAllTask");
		setTimeout(function(){location.href = "list.html";})
	},
	//回退按钮的回调
	backAction:function(){
		if(["","getCardSuccess","connectWifiSuccess"].indexOf(this.connectStatus) > -1){
			common.nativeCall("showDialog","",{
				"title":"温馨提示",
				"content":"正在连接" + this.connectData.SSID + "您确认放弃吗？",
				"okName":"确认放弃",
				"cancelName":"取消",
				"okCallback":"connect.giveUpConnectCallback"
			})
			return;
		}
		location.href = "list.html";
	},
	getDataCallback:function(data){
		data = JSON.parse(data);
		data.SSID = decodeURIComponent(window.atob(data.SSID));
		this.connectData = data;
		this.connect();
		this.progressCircle(1,10);
		this.connectData.TYPE === "020" && (this.progressCircle(1,0),this.progressCircle(2,35));
	},
	init:function() {
		this.bindEvent();
		common.nativeCall("getData","connect.getDataCallback","pluginWiFiData");
		common.nativeCall("setBackAction","connect.backAction");
		common.buried("20003",0,{SSID:this.connectData.SSID,connectBSSID:this.connectData.BSSID});
	}
}
connect.init();