/* 单独改进 */

(function(window, document, Math) {
	function pullRefresh(el, options) {
		var el = typeof el == 'string' ? document.querySelector(el) : el;
		this.wrapper = el.classList.contains('iWrapper') ? el : el.querySelector('.iWrapper');
		if (!this.wrapper) {
			throw new Error('dom element can not be empty!');
		}

		this.options = {
			swipeup: true,			// boolean: 是否允许上滑刷新
			swipedn: true,			// boolean: 是否允许下滑加载
			autoplay: true,			// boolean: 是否自动运行一次
			upStartText: '下拉刷新',
			upReadyText: '释放立即刷新',
			upDoingText: '正在加载…',
			upEndText: '刷新成功',
			dnStartText: '下拉可以搜索周边的热点哦！',
			dnDoingText: '加载中…',
			dnEndText: '加载成功',
			tipsText: '',
			scrollY: 0,				// number: 初始滑动位置
			probeType: 2,			// number: 滚动触发状态（1 滚动不繁忙的时候触发，2 滚动时每隔一定时间触发，3 每滚动一像素触发一次）
			nowNumber: 1,			// number：当前页码
			maxNumber: 0,			// number: 最大页码，0为不限
			maxCallFn: null,		// function: 超过最大页码时执行的函数（当 maxNumber > 0 时才生效）
			getDataFn: null,		// function: 获取数据函数; 入参：number 当前页码，callback 回调函数; 出参：string html字符串（页面的其它操作可自行编写，只返回字符串即可）
			scrollStartFn: null,
			scrollFn: null,
			scrollEndFn: null,
			touchStartFn: null,
			touchEndFn: null
		};
		if (options) {
			for ( var i in options ) {
				this.options[i] = options[i];
			}
		}

		this.scroller = this.wrapper.children[0];
		this.mainer = this.scroller.querySelector('.iMainer');
		this.lister = this.scroller.querySelector('.iInfoer');
		this.events = {};
		this.pullerUp = null;
		this.pullerUpInfo = null;
		this.pullerUpHeight = 0;
		this.pullerDn = null;
		this.pullerDnInfo = null;
		this.pullerDnHeight = 0;
		this.scroll = null;
		this.isScroll = false;
		this.isUpdate = false;
		this.isTouch = false;
		this.speed = 300;
		this.pageNumber = this.options.nowNumber;
		this.mainHeight = this.wrapper.offsetHeight;
		this.init();
	}

	pullRefresh.prototype = {
		isFunction: function(fn) {
			return typeof(fn) == 'function' ? true : false;
		},
		bind: function() {
			var body = document.body;
			if (!body.dataset.init) {
				this.addEvent(body, 'touchmove', function(e) {e.preventDefault();});
				body.style.overflow = 'hidden';
				body.dataset.init = true;
			}
			// 滑动内容最小高度大于一屏
			if (!this.options.swipeup && !this.options.swipedn) this.mainHeight += 1;
			this.mainer.style.minHeight = this.mainHeight + 'px';
			// 插入上滑和下滑提示标签
			if (this.options.swipeup) {
				this.pullerUp = document.createElement('div');
				this.pullerUp.className = 'iScroll-puller iScroll-puller-up';
				this.pullerUp.innerHTML = '<span class="iScroll-puller-info"></span>';
				// this.wrapper.appendChild(this.pullerUp);
				this.scroller.insertBefore(this.pullerUp, this.mainer);
				this.pullerUpInfo = this.pullerUp.children[0];
				this.pullerUpHeight = this.pullerUp.offsetHeight;
				this.pullerUp2 = document.querySelector('.tipsTxt');
			}
			if (this.options.swipedn) {
				this.pullerDn = document.createElement('div');
				this.pullerDn.className = 'iScroll-puller iScroll-puller-dn';
				this.pullerDn.innerHTML = '<span class="iScroll-puller-info"></span>';
				this.scroller.appendChild(this.pullerDn);
				this.pullerDnInfo = this.pullerDn.children[0];
				this.pullerDnHeight = this.pullerDn.offsetHeight;
			}
			// 配置iScroll
			this.scroll = new IScroll(this.wrapper, {probeType: this.options.probeType, tap: true, click: true, startY: this.options.scrollY-this.pullerUpHeight});
			this.scroll.on('scrollStart', function() {
				// console.log('fn-----scrollStart');
				this.isScroll = true;
				if (this.options.swipeup) {
					if (body.dataset.info == 'none') {
						this.pullerUp.classList.add('none');
						this.pullerUp2.innerHTML = this.options.dnStartText;
					} else {
						this.pullerUp.classList.remove('none');
						this.pullerUp.classList.remove('loading');
						this.pullerUpInfo.innerHTML = this.options.upStartText;
					}
				}
				if (this.options.swipedn) {
					this.pullerDn.classList.remove('loading');
					this.pullerDnInfo.innerHTML = this.options.dnStartText;
				}
				if (this.isFunction(this.options.scrollStartFn)) {
					this.options.scrollStartFn();
				}
			}.bind(this));
			this.scroll.on('scroll', function() {
				// console.log('fn-----scroll');
				if (this.options.swipeup && this.options.upReadyText != this.options.upStartText) {
					if (body.dataset.info == 'none') {
						this.pullerUp2.innerHTML = this.scroll.y >= 0 ? this.options.upReadyText : this.options.dnStartText;
					} else {
						this.pullerUpInfo.innerHTML = this.scroll.y >= 0 ? this.options.upReadyText : this.options.upStartText;
					}
				}
				if (this.isFunction(this.options.scrollFn)) {
					this.options.scrollFn();
				}
				// console.log(this.directionY);
			}.bind(this));
			this.scroll.on('scrollEnd', function() {
				if (this.options.swipeup && this.scroll.y > -this.pullerUpHeight && !this.isUpdate) {
					this.scroll.scrollTo(0, -this.pullerUpHeight, this.speed);
				}
				if (this.options.swipedn && this.scroll.y < this.scroll.maxScrollY + this.pullerDnHeight && !this.isUpdate) {
					this.pullDn();
				}
				if (!this.isScroll) return;
				if (this.isFunction(this.options.scrollEndFn)) {
					this.options.scrollEndFn();
				}
				this.isScroll = false;
				// console.log('fn-----scrollEnd');
			}.bind(this));
			this.addEvent(this.wrapper, 'touchstart', function() {
				// console.log('fn-----touchstart');
				this.isTouch = true;
				if (this.isFunction(this.options.touchStartFn)) {
					this.options.touchStartFn();
				}
			}.bind(this));
			this.addEvent(this.wrapper, 'touchend', function() {
				// console.log('fn-----touchend');
				this.isTouch = false;
				// this.isUpdate = false;
				if (this.options.swipeup && this.scroll.y > 0) {
					this.pullUp();
				}
				if (this.options.swipedn && this.scroll.y < this.scroll.maxScrollY + this.pullerDnHeight) {
					this.pullDn();
				}
				if (this.isFunction(this.options.touchEndFn)) {
					this.options.touchEndFn();
				}
			}.bind(this));
		},
		addEvent: function(el, type, fn, capture) {
			this.events[type] = fn;
			el.addEventListener(type, this.events[type], !!capture);
		},
		removeEvent: function(el, type, fn, capture) {
			var fn = this.events[type];
			el.removeEventListener(type, fn, !!capture);
		},
		pullUp: function() {
			// console.log('fn-----pullUp');
			this.pageNumber = 1;
			// this.mainer.style.top = this.pullerUpHeight + 'px';
			if (document.body.dataset.info == 'none') {
				this.pullerUp2.innerHTML = this.options.upDoingText;
			} else {
				this.pullerUp.classList.add('loading');
				this.pullerUpInfo.innerHTML = this.options.upDoingText;
			}
			this.getData('up');
		},
		pullDn: function() {
			// console.log('fn-----pullDn');
			this.pageNumber++;
			this.pullerDn.classList.add('loading');
			this.pullerDnInfo.innerHTML = this.options.dnDoingText;
			this.getData('dn');
		},
		getData: function(dir) {
			// console.log('fn-----getData');
			this.isUpdate = true;
			try {
				// 设置延时时间，使页面loading效果不少于500ms（初始加载例外）
				var duration = !dir ? 0 : 500;
				// 超过最大页码时进行回调
				if (this.options.maxNumber > 0 && this.options.maxNumber < this.pageNumber) {
					setTimeout(function() {
						this.render(dir);
						if (this.isFunction(this.options.maxCallFn)) {
							this.options.maxCallFn();
						}
					}.bind(this), duration);
					return;
				}
				// 获取数据然后渲染页面
				if (this.isFunction(this.options.getDataFn)) {
					var timeStart = new Date();
					this.options.getDataFn(this.pageNumber, function(html, target) {
						// 回传的 target 为 dom 标签
						var timeEnd = new Date();
						duration = Math.max(duration - (timeEnd - timeStart), 0);
						setTimeout(function() {
							this.render(dir, html, target);
						}.bind(this), duration);
					}.bind(this));
				} else {
					setTimeout(function() {
						this.render(dir);
					}.bind(this), duration);
				}
			} catch(e) {}
		},
		render: function(dir, html, target) {
			// console.log('fn-----render');
			var dir = dir || '';
			var str = html || '';
			var lister = target || this.lister;
			// 判断是上滑刷新、下滑加载还是默认加载，并把数据输出在页面
			switch (dir) {
				case 'up':
					// 必须当手指松开后才会渲染页面（在通用插件中，有定时三秒自动刷新列表的功能，在此时下拉刷新时有时会自动弹上去，此处写法为避免类似BUG）
					if (!this.isTouch) {
						if (document.body.dataset.info == 'none') {
							this.pullerUp2.innerHTML = this.options.dnStartText;
						} else {
							this.pullerUp.classList.remove('loading');
							this.pullerUpInfo.innerHTML = this.options.upEndText;
						}
						lister.innerHTML = str == '' ? this.options.tipsText : str;
						// this.mainer.style.top = 0;
						this.scroll.refresh();
						setTimeout(function() {
							this.scroll.scrollTo(0, -this.pullerUpHeight, this.speed);
						}.bind(this), 150);
					}
					break;
				case 'dn':
					this.pullerDn.classList.remove('loading');
					this.pullerDnInfo.innerHTML = this.options.dnEndText;
					if (str == '') {
						this.pageNumber--;
						this.scroll.scrollTo(0, this.scroll.maxScrollY + this.pullerDnHeight, this.speed);
					} else {
						// 必须用创建标签再插入的方式来添加内容，否则在移动设备加载新的内容时图片会闪动
						var el = document.createElement('div');
						el.innerHTML = str;
						lister.appendChild(el);
						if (this.mainer.offsetHeight == this.mainHeight) {
							this.scroll.scrollTo(0, this.scroll.maxScrollY + this.pullerDnHeight, this.speed);
						} else {
							this.scroll.refresh();
						}
					}
					break;
				default:
					lister.innerHTML = str == '' ? this.options.tipsText : str;
					this.scroll.refresh();
			}
			this.isUpdate = false;
		},
		destroy: function() {
			this.scroll.destroy();
			this.removeEvent(this.wrapper, 'touchstart');
			this.removeEvent(this.wrapper, 'touchend');
			var body = document.body;
			this.removeEvent(body, 'touchmove');
			body.style.overflow = 'auto';
			delete body.dataset.init;
			this.events = {};
		},
		init: function() {
			this.bind();
			if (this.options.autoplay) this.getData();
		}
	};

	window.pullRefresh = pullRefresh;

})(window, document, Math);

// 使用示例：
/*var puller = new pullRefresh('.iWrapper', {
	getDataFn: function(number, callback) {
		var html = '';
		// 根据页码获取接口数据，然后进行处理生成html标签
		html = '...';
		// 执行回调函数，把html回传
		if (typeof(callback) == 'function') callback.call(this, html);
	}
});*/