// 获取CSS3前缀
function _vendor() {
	var elementStyle = document.createElement('div').style,
		vendors = ['t', 'webkitT', 'MozT', 'msT', 'OT'],
		transform,
		i = 0,
		l = vendors.length;
	for ( ; i < l; i++ ) {
		transform = vendors[i] + 'ransform';
		if ( transform in elementStyle ) return vendors[i].substr(0, vendors[i].length-1);
	}
	return false;
}
function _prefixStyle(style) {
	var vendor = _vendor();
	if ( vendor === false ) return false;
	if ( vendor === '' ) return style;
	return vendor + style.charAt(0).toUpperCase() + style.substr(1);
}

var _transform = _prefixStyle('transform');
var _transition = _prefixStyle('transition');
var _scroll = null;
var _scrollCallback = false;

window.wifilist = {
	debug: false,
	data: {
		SSID: '',
		SSIDdecode: '',
		connectSSID: '',
		connectSSIDdecode: '',
		connectBSSID: '',
		connectLEVEL: '',
		connectTYPE: '',
		checkStatus: '{"wifiStatus":"WIFI_NO_OPEN"}'
	},
	loaded: 0,
	scroll: null,
	scrollcb: null,
	version: 1001,
	// 显示弹框
	showDialog: function(id) {
		[].slice.call(document.querySelectorAll('.dialog-page')).forEach(function(item) {
			item.classList[item.id == id ? 'add' : 'remove']('show');
		});
	},
	// 隐藏弹框
	hideDialog: function() {
		[].slice.call(document.querySelectorAll('.dialog-page')).forEach(function(item) {
			item.classList.remove('show');
		});
	},
	// 方法调用
	nativeCall: function(method,callback,param,testStr) {
		console.log('fn-----' + method + '----' + callback);
		if (this.debug) {
			if (callback && testStr) wifilist[callback.split('.')[1]](testStr);
		} else {
			common.nativeCall(method,callback,param);
		}
	},
	// 解码（经过讨论，编码方式最后改为先encodeURIComponent再base64的方式，解密则反之）
	decode: function(str) {
		try {
			return decodeURIComponent(window.atob(str));
		} catch(e) {
			return str;
		}
	},
	// 绑定事件
	bindEvent: function() {
		var pageX, pageY;
		document.addEventListener('touchstart', function(e) {
			var touch = e.changedTouches[0];
			pageX = touch.pageX;
			pageY = touch.pageY;
		}, false);
		document.addEventListener('touchend', function(e) {
			var touch = e.changedTouches[0];
			pageX -= touch.pageX;
			pageY -= touch.pageY;
			if (Math.abs(pageX) > 5 || Math.abs(pageY) > 5) return;
			var that = e.target;
			var action = that.dataset.action || that.parentNode.dataset.action;
			if (action && action == that.parentNode.dataset.action) that = e.target.parentNode;
			// if (that.nodeName.toUpperCase() == 'INPUT') that.focus();
			switch (action) {
				case 'goback':
					this.backAction();
					break;
				case 'help':
					location.href = 'qa.html';
					break;
				case 'onoff':
					// if (that == e.target) {
						// that.classList.add('disabled');
						var type = '1';
						if (that.classList.contains('on')) {
							type = '0';
						}
						this.switchWifi(type);
					// }
					break;
				case 'stop':
					common.buried('13001','1');
					common.nativeCall("ignoreSSID","wifilist.ignoreSSIDCallback",{"SSID":this.data.SSID});
					break;
				case 'goweb':
					common.buried('13001','2');
					this.data.connectSSID = this.data.SSID;
					this.checkLogin();
					break;
				case 'openwifi':
					// document.querySelector('.wifi-onoff').classList.add('disabled');
					this.data.checkStatus = '{"wifiStatus":"WIFI_IDLE","SSID":"' + window.btoa(encodeURIComponent("ChinaNet")) + '"}';
					this.switchWifi('1');
					break;
				case 'connect':
					this.data.connectSSID = that.dataset.ssid;
					this.data.connectSSIDdecode = this.decode(that.dataset.ssid);
					this.data.connectBSSID = that.dataset.bssid;
					this.data.connectLEVEL = that.dataset.level;
					this.data.connectTYPE = that.dataset.types;
					that.classList.add('checked');
					setTimeout(function() {
						that.classList.remove('checked');
					}, 100);
					if (this.data.SSID == '') {
						if (this.data.connectLEVEL <= 1) {
							common.nativeCall("showDialog","",{
								"title":"温馨提示",
								"content": this.data.connectSSIDdecode + " 信号较弱，网络可能不稳定，连接成功率低，是否继续？",
								"okName":"试一下",
								"cancelName":"暂不连接",
								"okCallback":"wifilist.connectYes",
								"cancelCallback":"wifilist.connectNo",
								"backgroundClose":false
							});
						} else {
							this.checkLogin();
						}
					} else {
						if (this.data.SSID != this.data.connectSSID) {
							common.nativeCall("showDialog","",{
								"title":"温馨提示",
								"content": "您已成功连接 " + this.data.SSIDdecode + "，确认要切换成 " + this.data.connectSSIDdecode + " 吗？",
								"okName":"确认切换",
								"cancelName":"暂不切换",
								"okCallback":"wifilist.connectTab",
								"cancelCallback":"wifilist.connectNoTab",
								"backgroundClose":false
							});
						}
					}
					break;
				case 'dialogClose':
					this.hideDialog();
					break;
				case 'dialogGonow':
					if (that.classList.contains('disabled')) return;
					var dialog = that.parentNode.parentNode.parentNode;
					var hasuser = dialog.classList.contains('hasuser');
					var elPassword = dialog.querySelector('.password');
					var password = elPassword.value;
					elPassword.blur();
					var username = '';
					if (hasuser) {
						var elUsername = dialog.querySelector('.username');
						username = elUsername.value;
						elUsername.blur();
					}
					/*if (password.trim().length < 8) {
						var elTips = dialog.querySelector('.tips');
						elTips.classList.add('error');
						elTips.innerHTML = '密码不得少于8位';
					} else {*/
						common.nativeCall('connectWifi', 'wifilist.connectWifiCallback', {"SSID":this.data.connectSSID,"password":password,"identity":username,"isPingAnWifi":""});
						this.hideDialog();
					// }
					break;
				case 'seePsw':
					var input = that.parentNode.querySelector('.password');
					if (!that.classList.contains('see')) {
						input.type = 'text';
						that.classList.add('see');
					} else {
						input.type = 'password';
						that.classList.remove('see');
					}
					break;
			}
		}.bind(this), false);
		[].slice.call(document.querySelectorAll('.input')).forEach(function(item) {
			item.addEventListener('input', function(e) {
				var submit = true;
				var dialog = e.target.parentNode.parentNode.parentNode;
				[].slice.call(dialog.querySelectorAll('.input')).forEach(function(item2) {
					if (item2.value == '') submit = false;
				});
				dialog.querySelector('.btn-gonow').classList[submit ? 'remove' : 'add']('disabled');
			}, false);
		});
	},
	// 热点连接
	checkLogin: function() {
		switch (this.data.connectTYPE) {
			// 附近的wifi有密码
			case '021':
				this.nativeCall('getWifiType', 'wifilist.getWifiTypeCallback', {"SSID":this.data.connectSSID,"BSSID":this.data.connectBSSID}, '{"type":"eap"}');
				break;
			// 支持的wifi
			case '010':
			// 附近的wifi_无密码
			case '020':
			// 默认
			default:
				this.nativeCall('checkLogin', 'wifilist.checkLoginCallback', {}, '{"status":"success"}');
				// if (this.debug) {
				// 	this.checkLoginCallback('{"status":"success"}');
				// } else {
				// 	common.nativeCall("checkLogin","wifilist.checkLoginCallback");
				// }
				break;
		}
	},
	// 获取wifi类型
	getWifiTypeCallback: function(data) {
		data = this.formatToJSON(data);
		switch (data.type) {
			// 企业wifi
			case 'eap':
				var elLogin = document.getElementById('loginUserpsw');
				elLogin.querySelector('.dialog-thead').innerHTML = this.data.connectSSIDdecode;
				elLogin.querySelector('.username').value = '';
				elLogin.querySelector('.password').value = '';
				elLogin.querySelector('.tips').classList.remove('error');
				elLogin.querySelector('.tips').innerHTML = '为了您的信息安全，我们不会记录您的密码，请放心使用。';
				elLogin.querySelector('.btn-gonow').classList.add('disabled');
				this.showDialog(elLogin.id);
				break;
			// 个人wifi
			case 'wep':
			case 'psk':
				var elLogin = document.getElementById('loginOnlypsw');
				elLogin.querySelector('.dialog-thead').innerHTML = this.data.connectSSIDdecode;
				elLogin.querySelector('.password').value = '';
				elLogin.querySelector('.tips').classList.remove('error');
				elLogin.querySelector('.tips').innerHTML = '为了您的信息安全，我们不会记录您的密码，请放心使用。';
				elLogin.querySelector('.btn-gonow').classList.add('disabled');
				this.showDialog(elLogin.id);
				break;
			case '':
				this.nativeCall('checkLogin', 'wifilist.checkLoginCallback', {}, '{"status":"success"}');
				break;
		}
	},
	connectYes: function() {
		common.buried("13003",2,{SSID:this.data.connectSSID,BSSID:this.data.connectBSSID});
		this.checkLogin();
	},
	connectNo: function() {
		common.buried("13003",1,{SSID:this.data.connectSSID,BSSID:this.data.connectBSSID});
	},
	connectTab: function() {
		common.buried("13003",4,{SSID:this.data.connectSSID,BSSID:this.data.connectBSSID});
		this.checkLogin();
	},
	connectNoTab: function() {
		common.buried("13003",3,{SSID:this.data.connectSSID,BSSID:this.data.connectBSSID});
	},
	// 忽略wifi回调
	ignoreSSIDCallback: function(data) {
		data = this.formatToJSON(data);
		if (data.status == 'success') this.start();
	},
	// 检查登入状态
	checkLoginCallback: function(data) {
		data = this.formatToJSON(data);
		var json = {
			"TYPE": this.data.connectTYPE,
			"SSID": this.data.connectSSID,
			"BSSID": this.data.connectBSSID
		};
		localStorage.setItem('pluginWiFiData', JSON.stringify(json));
		common.nativeCall('saveData', '', {"key":"pluginWiFiData", "data":JSON.stringify(json)});
		location.href = data.status === "success" ? "connect.html" : "login.html";
	},
	// 立即连接回调
	connectWifiCallback: function(data) {
		// 
	},
	// 初始状态检测回调
	checkCurrentWifiStateCallback: function(data) {
		document.getElementById('dialogLoading').classList.remove('show');
		data = this.formatToJSON(data);
		var onoff = document.querySelector('.wifi-onoff'),
			onoffYD = onoff.querySelector('span'),
			text = document.querySelector('.wifi-text'),
			title1 = text.querySelector('.title'),
			title2 = text.querySelector('.title-sub'),
			btns = document.querySelector('.wifi-btns'),
			btnStop = btns.querySelector('.btn-stop'),
			btnGoweb = btns.querySelector('.btn-goweb'),
			noopen = document.getElementById('wifiNoopen'),
			lister = document.getElementById('wifiLister');
		this.data.SSID = (!data.SSID || data.SSID == null) ? '' : data.SSID;
		this.data.SSIDdecode = this.data.SSID == '' ? '' : this.decode(this.data.SSID);
		// onoff.classList.remove('disabled');
		if (data.wifiStatus == 'WIFI_NO_OPEN') {
			// wifi关闭
			onoff.classList.remove('on');
			noopen.classList.add('show');
			lister.classList.remove('show');
			text.classList.remove('showsub');
			title1.innerHTML = 'WiFi未开启';
			btns.classList.add('none');
		} else {
			onoff.classList.add('on');
			noopen.classList.remove('show');
			lister.classList.add('show');
			this.getData();
			switch (data.wifiStatus) {
				// WiFi开启,没有连接任意ssid
				case 'WIFI_IDLE':
					text.classList.remove('showsub');
					title1.innerHTML = '未连接WiFi';
					btns.classList.add('none');
					break;
				// 正在搜索WiFi
				case 'SEARCHING_WIFI':
					text.classList.remove('showsub');
					title1.innerHTML = '正在搜索附近WiFi...';
					btns.classList.add('none');
					break;
				// 正在打开WiFi
				case 'OPENING_WIFI':
					text.classList.remove('showsub');
					title1.innerHTML = '正在打开WiFi...';
					btns.classList.add('none');
					break;
				// 能上网
				case 'CONNECT_PA_FREE_WIFI':
					text.classList.add('showsub');
					title1.innerHTML = this.data.SSIDdecode;
					title2.innerHTML = '可以上网';
					btns.classList.remove('none');
					btnStop.classList.remove('none');
					btnGoweb.classList.add('none');
					break;
				// 非Protal类不能上网
				case 'CONNECT_NOT_PORTAL_WIFI_NO_NET':
					text.classList.add('showsub');
					title1.innerHTML = this.data.SSIDdecode;
					title2.innerHTML = '不能上网';
					btns.classList.remove('none');
					btnStop.classList.remove('none');
					btnGoweb.classList.add('none');
					break;
				// protal类支持wifi不能上网
				case 'CONNECT_PORTAL_PA_WIFI_NO_NET':
					text.classList.add('showsub');
					title1.innerHTML = this.data.SSIDdecode;
					title2.innerHTML = '不能上网，点击[帮我上网]';
					btns.classList.remove('none');
					btnStop.classList.add('none');
					btnGoweb.classList.remove('none');
					break;
				// protal类不支持wifi不能上网
				case 'CONNECT_PORTAL_OTHER_WIFI_NO_NET':
					text.classList.add('showsub');
					title1.innerHTML = this.data.SSIDdecode;
					title2.innerHTML = '已连接，需登录';
					btns.classList.remove('none');
					btnStop.classList.add('none');
					btnGoweb.classList.remove('none');
					break;
				// 用户名或密码错误
				case 'PWD_OR_UN_ERROR':
					if (this.data.connectSSIDdecode != '') { 
						var elLogin = document.getElementById('loginUserpsw');
						elLogin.querySelector('.dialog-thead').innerHTML = this.data.connectSSIDdecode;
						elLogin.querySelector('.password').value = '';
						elLogin.querySelector('.tips').classList.add('error');
						elLogin.querySelector('.tips').innerHTML = '用户名或密码错误';
						// elLogin.querySelector('.normal').classList.add('none');
						// elLogin.querySelector('.error').classList.remove('none');
						elLogin.querySelector('.btn-gonow').classList.add('disabled');
						this.showDialog(elLogin.id);
					}
					break;
				// 密码错误
				case 'PWD_ERROR':
					if (this.data.connectSSIDdecode != '') {
						var elLogin = document.getElementById('loginOnlypsw');
						elLogin.querySelector('.dialog-thead').innerHTML = this.data.connectSSIDdecode;
						elLogin.querySelector('.password').value = '';
						elLogin.querySelector('.tips').classList.add('error');
						elLogin.querySelector('.tips').innerHTML = '密码错误';
						// elLogin.querySelector('.normal').classList.add('none');
						// elLogin.querySelector('.error').classList.remove('none');
						elLogin.querySelector('.btn-gonow').classList.add('disabled');
						this.showDialog(elLogin.id);
					}
					break;
				// 正在连接WiFi
				case 'CONNECTING_WIFI':
					text.classList.remove('showsub');
					title1.innerHTML = '正在连接WiFi...';
					btns.classList.add('none');
					break;
			}
		}
		if (this.loaded < 2) {
			this.loaded++;
			if (this.loaded > 1) {
				onoff.style[_transition] = 'all 0.3s ease';
				onoffYD.style[_transition] = 'all 0.3s ease';
			}
		}
	},
	// 获取信息
	getData: function(number, callback) {
		if (typeof(callback) == 'function') {
			_scrollCallback = callback;
			this.nativeCall('pullTOrefreshWifiList', 'wifilist.pullTOrefreshWifiListCallback', {}, '{"Unsupported":[{"type":"021","BSSID":"24:de:c6:c7:2f:5d","SSID":"UEFfV0xBTl9NQQ==","level":"3"},{"type":"021","BSSID":"24:de:c6:c7:2f:5e","SSID":"UEFfV0xBTl9NUg==","level":"3"},{"type":"021","BSSID":"24:de:c6:c7:2f:5b","SSID":"UEFfV0xBTg==","level":"3"},{"type":"021","BSSID":"24:de:c6:c7:2f:5f","SSID":"UEFfV0xBTl9NQUM=","level":"3"},{"type":"021","BSSID":"24:de:c6:c7:2f:59","SSID":"UEFfV0xBTl9HVUVTVA==","level":"3"},{"type":"021","BSSID":"24:de:c6:c7:2f:58","SSID":"YXBwbGU=","level":"3"},{"type":"020","BSSID":"24:de:c6:c7:2f:5a","SSID":"Ymx1ZXNlYS1mcmVlLTE=","level":"3"},{"type":"021","BSSID":"00:16:6d:30:18:6f","SSID":"dGVzdDk5OQ==","level":"3"},{"type":"020","BSSID":"12:34:cb:68:26:3c","SSID":"JUU1JUI5JUJGJUU0JUI4JTlDJUU3JTlDJTgxJUU1JThGJUEzJUU4JTg1JTk0 JUU1JThDJUJCJUU5JTk5JUEy","level":"3"},{"type":"020","BSSID":"00:34:cb:68:26:3c","SSID":"U1NJRC0yLjRH","level":"3"},{"type":"021","BSSID":"00:08:d2:ed:14:3b","SSID":"eWFuZmEtdGVzdC01Rw==","level":"3"},{"type":"021","BSSID":"4c:e6:76:cc:51:e9","SSID":"REQtV1JU","level":"3"},{"type":"020","BSSID":"02:08:d2:ec:14:3b","SSID":"cGluZ2Fud2lmaS03Zy01Rw==","level":"3"},{"type":"020","BSSID":"ec:88:8f:d8:14:62","SSID":"T3BlbldydA==","level":"3"},{"type":"020","BSSID":"a8:80:38:21:32:90","SSID":"UGluZ0FuLVdpZmk=","level":"3"},{"type":"020","BSSID":"d4:68:4d:6d:0b:bc","SSID":"JUU4JUI5JUFEJUU4JUI5JUFEV0lGSSVFNyVBNyU5MiVFNiU5RCU4MCVFNyVC RSVBNA==","level":"3"},{"type":"020","BSSID":"d4:68:4d:2d:0b:bc","SSID":"Q2VuZ0NlbmdXSUZJ","level":"3"},{"type":"021","BSSID":"e0:19:1d:52:60:a2","SSID":"dGVzdDEy","level":"2"},{"type":"021","BSSID":"d4:ee:07:01:1b:a2","SSID":"U2hpYnV5YQ==","level":"2"},{"type":"021","BSSID":"3c:67:fb:50:6c:0a","SSID":"NEclMjB1RmlfQzBB","level":"2"},{"type":"020","BSSID":"24:de:c6:cf:82:76","SSID":"UGluZ0FuTmV0","level":"2"},{"type":"021","BSSID":"ae:fd:ec:4f:71:2a","SSID":"aVBob25l","level":"1"}],"Supported":[{"type":"010","BSSID":"00:07:74:a0:0b:09","SSID":"YXAtcGEwMzM=","level":"2"}]}');
		} else {
			// _scroll.isUpdate = true;
			_scrollCallback = null;
			this.nativeCall('refreshWifiList', 'wifilist.refreshWifiListCallback', {}, '{"Supported":[],"Unsupported":[]}');
		}
	},
	// 数据处理
	refreshList: function(data) {
		data = this.formatToJSON(data);
		var isNone = false;
		if (!data || !data.Unsupported || !data.Supported || (data.Unsupported.length == 0 && data.Supported.length == 0)) isNone = true;
		if (!isNone) {
			document.body.dataset.info = 'list';
			document.getElementById('listBox').classList.remove('none');
			document.getElementById('noneBox').classList.add('none');
			_scroll.pullerUp.classList.remove('none');
		} else {
			document.body.dataset.info = 'none';
			document.getElementById('listBox').classList.add('none');
			document.getElementById('noneBox').classList.remove('none');
			_scroll.pullerUp.classList.add('none');
		}
		var str = this.getHtml(data);
		return str;
	},
	// 刷新WiFi列表数据的回调
	refreshWifiListCallback: function(data) {
		var html = this.refreshList(data);
		common.nativeCall('log', 'refresh', html);
		_scroll.render('up', html);
	},
	// 下拉WiFi列表数据的回调
	pullTOrefreshWifiListCallback: function(data) {
		var html = this.refreshList(data);
		_scrollCallback.call(this, html);
	},
	// 页面渲染
	getHtml: function(data) {
		var str = '';
		var name = {
			'cmcc-web': '中国移动',
			'cmcc': '中国移动',
			'cmcc-vip': '中国移动',
			'cmcc-auto': '中国移动',
			'and-business': '中国移动',
			'chinaunicom': '中国联通',
			'chinanet': '中国电信'
		};
		var supported = data.Supported;
		var unsupported = data.Unsupported;
		if (!!supported) {
			str += '<h3 class="list-thead">专享免费WiFi</h3><div class="list-tbody" id="listPingan">';
			if (supported.length > 0) {
				for (var i = 0, l = supported.length; i < l; i++) {
					var SSID = supported[i].SSID;
					var SSIDdecode = this.decode(SSID);
					str += '<div class="list-item" data-ssid="' + SSID + '" data-bssid="' + supported[i].BSSID + '" data-level="' + supported[i].level + '" data-types="' + supported[i].type + '" data-action="connect"><p class="item-icon ' + ({'1':'level01','2':'level02','3':'level03'}[supported[i].level] || '') + '"></p><p class="item-ssid">' + SSIDdecode + '</p><p class="item-name">' + (name[SSIDdecode.toLowerCase()] || '免费WiFi') + '</p>' + (SSID == this.data.SSID ? '<p class="item-tag">已连接</p>' : '') + '</div>';
				}
			} else {
				str += '<div class="list-item null"><p class="item-icon"></p><p class="item-ssid">附近无可用的运营商WiFi</p></div>';
			}
			str += '</div>';
		}
		if (!!unsupported) {
			str += '<h3 class="list-thead">附近的WiFi</h3><div class="list-tbody" id="listNearby">';
			if (unsupported.length > 0) {
				for (var i = 0, l = unsupported.length; i < l; i++) {
					var SSID = unsupported[i].SSID;
					var SSIDdecode = this.decode(SSID);
					str += '<div class="list-item" data-ssid="' + SSID + '" data-bssid="' + unsupported[i].BSSID + '" data-level="' + unsupported[i].level + '" data-types="' + unsupported[i].type + '" data-action="connect"><p class="item-icon ' + ({'1':'level01','2':'level02','3':'level03'}[unsupported[i].level] || '') + '"></p><p class="item-ssid">' + SSIDdecode + '</p><p class="item-name">' + (unsupported[i].type == '020' ? '无密码' : '需密码') + '</p>' + (SSID == this.data.SSID ? '<p class="item-tag">已连接</p>' : '') + '</div>';
				}
			} else {
				str += '<div class="list-item null"><p class="item-icon"></p><p class="item-ssid">附近无可用的WiFi</p></div>';
			}
			str += '</div>';
		}
		return str;
	},
	// wifi开关
	switchWifi: function(type) {
		this.nativeCall('switchWifi', 'wifilist.switchWifiCallback', {"type":type}, '{"status":"success","type":"' + type + '"}');
		// if (this.debug) {
		// 	this.switchWifiCallback('{"status":"success","type":"' + type + '"}');
		// } else {
		// 	common.nativeCall("switchWifi","wifilist.switchWifiCallback",{"type":type});
		// }
		// if (type == '1' && this.version >= 1002) {
		// 	document.querySelector('.wifi-text .title-sub').innerHTML = '正在打开WLAN……';
		// }
	},
	// wifi开关回调
	switchWifiCallback: function(data) {
		this.start();
	},
	// 滑动广告
	advertisementVisibility: function(type) {
		this.nativeCall('advertisementVisibility', 'wifilist.advertisementVisibilityCallback', {"type":type}, '{"status":"success","type":"' + type + '"}');
	},
	// 滑动广告回调
	advertisementVisibilityCallback: function(data) {
	},
	// 点击后退按钮执行的操作
	backAction: function() {
		common.buried('13003','5');
		common.nativeCall("finish");
	},
	setVersion: function(str) {
		this.version = parseInt(str);
	},
	start: function() {
		this.nativeCall('checkCurrentWifiState', 'wifilist.checkCurrentWifiStateCallback', {}, this.data.checkStatus);
		// if (this.debug) {
		// 	this.checkCurrentWifiStateCallback('{"wifiStatus":"WIFI_IDLE","SSID":"ChinaNet"}');
		// } else {
		// 	common.nativeCall("checkCurrentWifiState","wifilist.checkCurrentWifiStateCallback");
		// }
	},
	formatToJSON: function(json) {
		// var json = json.replace(/""/g,'"');
		// json = json.replace(/:",/g,':"",');
		// json = json.replace(/:"}/g,':""}');
		// var json = json.replace(/\\/g,'');
		try {
			return JSON.parse(json);
		} catch (e) {
			return false;
			console.log(e);
		}
	},
	// 初始化
	init: function() {
		// 设置页面地址
		common.nativeCall("setPageInfo","",{list:{url:"list.html"},connect:{url:"connect.html"},login:{url:"login.html"}});
		// 设置后退按钮的行为
		common.nativeCall("setBackAction","wifilist.backAction");
		// 获取版本号
		common.nativeCall("getVersionCode","wifilist.setVersion");
		// 埋点
		common.buried('13001','0');
		var lister = document.getElementById('wifiLister');
		lister.querySelector('.iInfoer').innerHTML = '';
		lister.classList.add('show');
		_scroll = new pullRefresh('#' + lister.id, {
			swipedn: false,
			autoplay: false,
			getDataFn: function(a, b) {
				this.getData(a, b);
			}.bind(this)
		});
		lister.classList.remove('show');
		this.bindEvent();
		this.start();
		// this.getWifiTypeCallback('{"type":"wep"}');
	}
};
setTimeout(function() {
	document.querySelector('.iMainer').style.minHeight = document.querySelector('.iWrapper').offsetHeight + 'px';
	wifilist.init();
}, 500);